# Configuration file for the Sphinx documentation builder.
#
# This file only contains a selection of the most common options. For a full
# list see the documentation:
# https://www.sphinx-doc.org/en/master/usage/configuration.html

# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
# import os
# import sys
# sys.path.insert(0, os.path.abspath('.'))


# -- Project information -----------------------------------------------------
project = '北大数瑞大数据区块链'
copyright = '2021, Peking University'
author = 'Peking University'

# The full version, including alpha/beta/rc tags
release = 'V1.0'


# -- General configuration ---------------------------------------------------

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.

html_theme = "sphinx_rtd_theme"
html_logo="_static/imgs/logo.png"
html_theme_options = {
'logo_only': True
}

source_parsers = {
    '.md': 'recommonmark.parser.CommonMarkParser',
}

source_suffix = ['.rst', '.md']

# source_suffix = {
#     '.rst': 'restructuredtext',
#     '.txt': 'markdown',
#     '.md': 'markdown'
# }

extensions = [
	'recommonmark',
	'sphinx_rtd_theme',
	'sphinx_markdown_tables'
]

html_favicon = "_static/imgs/favicon.ico"
# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = 'zh_CN'

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path.
exclude_patterns = []


# -- Options for HTML output -------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
#html_theme = 'alabaster'

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']

master_doc = 'index'


##latex_elements = {
##    'papersize': 'a4paper',
    # Additional stuff for the LaTeX preamble.
##    'preamble': '''
##\usepackage{xeCJK}
##\usepackage{indentfirst}
##\setlength{\parindent}{2em}
##\setCJKmainfont[BoldFont=STFangsong, ItalicFont=STKaiti]{STSong}
##\setCJKsansfont[BoldFont=STHeiti]{STXihei}
##\setCJKmonofont{STFangsong}
##''',
##}