#!/bin/bash
cd source
rm -rf ContractAPI.rst
rm -rf IDEUsage.rst
rm -rf InstallTips.rst
rm -rf Introduction.rst
rm -rf YJSAPI.rst
rm -rf YJSInDepth.rst
rm -rf conf.py
rm -rf index.rst

if [ $# -lt 1 ]; then
  export src=./markdown
elif [ $1 == "zryh" ] ; then
  export src=./markdown_ZRYH
elif [ $1 == "bdware" ] ; then
  export src=./markdown_BDWare
else
  echo "error arguments, use ./markdown"
  export src=./markdown
fi
cp ${src}/conf.py ./conf.py
cp ${src}/index.rst ./index.rst
pandoc ${src}/ContractAPI.md -f markdown -t rst  -o ContractAPI.rst
pandoc ${src}/IDEUsage.md -f markdown -t rst  -o IDEUsage.rst
pandoc ${src}/InstallTips.md -f markdown -t rst  -o InstallTips.rst
pandoc ${src}/Introduction.md -f markdown -t rst  -o Introduction.rst
pandoc ${src}/YJSAPI.md -f markdown -t rst  -o YJSAPI.rst
pandoc ${src}/YJSInDepth.md -f markdown -t rst  -o YJSInDepth.rst
cd ..
make clean
make html
